> ## Documentation Index
> Fetch the complete documentation index at: https://www.commercengine.io/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List all payment methods

> List all payment methods



## OpenAPI

````yaml get /payments/payment-methods
openapi: 3.1.0
info:
  version: '1.0'
  title: CE Storefront APIs
  summary: Customer-facing e-commerce API for building exceptional shopping experiences
  description: >-
    Public-facing API for Commerce Engine storefronts, enabling seamless
    shopping experiences with product browsing, cart management, checkout
    processing, user accounts, and order tracking. Perfect for building web,
    mobile, and headless commerce applications.
  contact:
    name: Support
    email: support@commercengine.io
    url: https://www.commercengine.io/contact-us
  license:
    url: https://www.commercengine.io/contact-us
    name: All Rights Reserved
servers:
  - url: https://staging.api.commercengine.io/api/v1/{store_id}/storefront
    description: Staging Server
    variables:
      store_id:
        description: Store ID
        default: store_id
    x-speakeasy-server-id: staging
  - url: https://prod.api.commercengine.io/api/v1/{store_id}/storefront
    description: Prod Server
    variables:
      store_id:
        description: Store ID
        default: store_id
    x-speakeasy-server-id: prod
security: []
tags:
  - name: Analytics
    description: Analytics
  - name: Auth
    description: auth
  - name: Campaigns
    description: Campaigns
  - name: Carts
    description: Carts
  - name: Catalog
    description: Catalog
  - name: Common
    description: Common
  - name: Coupons & promotions
    description: Coupons & promotions
  - name: Customers
    description: Customers
  - name: Juspay
    description: Juspay Payments
  - name: KYC
    description: KYC
  - name: Marketplace
    description: Marketplace
  - name: Orders
    description: Orders
  - name: Others
    description: Others
  - name: Payments
    description: Payments
  - name: PayU
    description: PayU Payments
  - name: POS
    description: POS
  - name: Shipping
    description: Shipping
  - name: Store
    description: Store
  - name: Subscriptions
    description: Subscriptions
externalDocs:
  url: https://llm-docs.commercengine.io
  description: Commerce Engine API Reference Documentation
paths:
  /payments/payment-methods:
    get:
      tags:
        - Payments
      summary: List all payment methods
      description: List all payment methods
      operationId: list-payment-methods
      parameters:
        - name: payment_method_type
          in: query
          description: Payment method type
          required: false
          schema:
            type: string
            enum:
              - card
              - upi
              - netbanking
              - wallet
              - manual
        - name: payment_provider_slug
          in: query
          description: Payment provider slug
          required: false
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  message:
                    type: string
                  success:
                    type: boolean
                  content:
                    properties:
                      payment_methods:
                        type: array
                        items:
                          oneOf:
                            - $ref: '#/components/schemas/PayuPaymentMethod'
                            - $ref: '#/components/schemas/JuspayPaymentMethod'
                            - $ref: '#/components/schemas/ManualPaymentMethod'
                    type: object
          links:
            CreateOrder:
              operationId: create-order
              description: >-
                Create an order with a payment method. Use
                `payment_provider_slug` and a `gateway_reference_id` from
                `details[].supported_reference_ids[]` to construct the
                `payment_method` payload.
            GetCardInfo:
              operationId: get-card-info
              description: >-
                Look up card BIN info to validate card brand support before
                creating an order with a new card.
            VerifyVpa:
              operationId: verify-vpa
              description: Validate a UPI VPA before creating an order with UPI Collect.
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
      security:
        - Authorization: []
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/operations/list-payment-methods
        description: API reference for the list-payment-methods operation
components:
  schemas:
    PayuPaymentMethod:
      title: PayuPaymentMethod
      type: object
      externalDocs:
        url: https://llm-docs.commercengine.io/storefront/schemas/PayuPaymentMethod
        description: API reference for the PayuPaymentMethod schema
      required:
        - id
        - name
        - type
        - payment_provider_slug
        - details
      properties:
        id:
          type: string
        name:
          type: string
        payment_instructions:
          type:
            - string
            - 'null'
        type:
          type: string
        payment_provider_slug:
          type: string
        details:
          type: array
          items:
            type: object
            required:
              - code
              - is_subscription_enabled
              - options
              - payment_method
            properties:
              code:
                type: string
              is_subscription_enabled:
                type: boolean
              options:
                type: array
                items:
                  type: object
                  required:
                    - bankcode
                    - icon_url
                    - is_subscription_enabled
                    - name
                    - pg
                  properties:
                    bankcode:
                      type: string
                    icon_url:
                      type: string
                    is_subscription_enabled:
                      type: boolean
                    name:
                      type: string
                    pg:
                      type: string
              payment_method:
                type: string
        order_params:
          type: object
    JuspayPaymentMethod:
      title: JuspayPaymentMethod
      type: object
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/schemas/JuspayPaymentMethod
        description: API reference for the JuspayPaymentMethod schema
      required:
        - id
        - name
        - type
        - payment_provider_slug
        - details
      properties:
        id:
          type: string
        name:
          type: string
        payment_instructions:
          type:
            - string
            - 'null'
        type:
          type: string
        payment_provider_slug:
          description: The slug of the payment provider in Commerce Engine.
          type: string
        details:
          type: array
          items:
            $ref: '#/components/schemas/JuspayPaymentMethodDetail'
        order_params:
          type: object
    ManualPaymentMethod:
      title: ManualPaymentMethod
      type: object
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/schemas/ManualPaymentMethod
        description: API reference for the ManualPaymentMethod schema
      required:
        - id
        - name
        - type
        - payment_provider_slug
        - details
      properties:
        id:
          type: string
        name:
          type: string
        payment_instructions:
          type:
            - string
            - 'null'
        type:
          type: string
        payment_provider_slug:
          type: string
        details:
          type: array
          items:
            type: object
        order_params:
          type: object
    JuspayPaymentMethodDetail:
      title: JuspayPaymentMethodDetail
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/schemas/JuspayPaymentMethodDetail
        description: API reference for the JuspayPaymentMethodDetail schema
      discriminator:
        propertyName: payment_method_type
        mapping:
          UPI:
            $ref: '#/components/schemas/JuspayUpiPaymentMethod'
          CARD:
            $ref: '#/components/schemas/JuspayCardPaymentMethod'
          NB:
            $ref: '#/components/schemas/JuspayNetbankingPaymentMethod'
          WALLET:
            $ref: '#/components/schemas/JuspayWalletPaymentMethod'
      oneOf:
        - $ref: '#/components/schemas/JuspayUpiPaymentMethod'
        - $ref: '#/components/schemas/JuspayCardPaymentMethod'
        - $ref: '#/components/schemas/JuspayNetbankingPaymentMethod'
        - $ref: '#/components/schemas/JuspayWalletPaymentMethod'
    JuspayUpiPaymentMethod:
      title: JuspayUpiPaymentMethod
      type: object
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/schemas/JuspayUpiPaymentMethod
        description: API reference for the JuspayUpiPaymentMethod schema
      required:
        - description
        - juspay_bank_code
        - juspay_bank_code_id
        - payment_method
        - payment_method_type
        - pm_response_description
        - supported_reference_ids
      properties:
        description:
          type: string
        juspay_bank_code:
          type: string
          enum:
            - UPI_COLLECT
            - UPI_PAY
            - UPI_QR
        juspay_bank_code_id:
          type: integer
        payment_method:
          type: string
          enum:
            - UPI_COLLECT
            - UPI_PAY
            - UPI_QR
        payment_method_type:
          type: string
          const: UPI
        pm_response_description:
          type: string
        supported_reference_ids:
          type: array
          items:
            type: string
    JuspayCardPaymentMethod:
      title: JuspayCardPaymentMethod
      type: object
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/schemas/JuspayCardPaymentMethod
        description: API reference for the JuspayCardPaymentMethod schema
      required:
        - description
        - payment_method
        - payment_method_type
        - pm_response_description
        - supported_reference_ids
        - validations
      properties:
        description:
          type: string
        payment_method:
          type: string
          enum:
            - VISA
            - MASTER
            - RUPAY
        payment_method_type:
          type: string
          const: CARD
        pm_response_description:
          type: string
        supported_reference_ids:
          type: array
          items:
            type: string
        validations:
          type: object
          properties:
            refund_support:
              type: boolean
          required:
            - refund_support
    JuspayNetbankingPaymentMethod:
      title: JuspayNetbankingPaymentMethod
      type: object
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/schemas/JuspayNetbankingPaymentMethod
        description: API reference for the JuspayNetbankingPaymentMethod schema
      required:
        - description
        - juspay_bank_code
        - juspay_bank_code_id
        - payment_method
        - payment_method_type
        - pm_response_description
        - supported_reference_ids
      properties:
        description:
          type: string
        juspay_bank_code:
          type: string
        juspay_bank_code_id:
          type: integer
        payment_method:
          type: string
        payment_method_type:
          type: string
          const: NB
        pm_response_description:
          type: string
        supported_reference_ids:
          type: array
          items:
            type: string
    JuspayWalletPaymentMethod:
      title: JuspayWalletPaymentMethod
      type: object
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/schemas/JuspayWalletPaymentMethod
        description: API reference for the JuspayWalletPaymentMethod schema
      required:
        - description
        - juspay_bank_code
        - juspay_bank_code_id
        - payment_method
        - payment_method_sub_type
        - payment_method_type
        - pm_response_description
        - supported_reference_ids
      properties:
        description:
          type: string
        juspay_bank_code:
          type: string
        juspay_bank_code_id:
          type: integer
        payment_method:
          type: string
        payment_method_sub_type:
          type: string
          const: WALLET
        payment_method_type:
          type: string
          const: WALLET
        pm_response_description:
          type: string
        supported_reference_ids:
          type: array
          items:
            type: string
        wallet_direct_debit_support:
          type: boolean
  responses:
    BadRequest:
      description: Bad request
      content:
        application/json:
          schema:
            type: object
            required:
              - message
              - success
              - code
            properties:
              message:
                type: string
                x-speakeasy-error-message: true
              success:
                type: boolean
              code:
                type: string
              error:
                type: object
    Unauthorized:
      description: Not authorized for given operation on the Resource
      content:
        application/json:
          schema:
            type: object
            required:
              - message
              - success
              - code
            properties:
              message:
                type: string
                examples:
                  - Not authorized for given operation on the Resource.
                x-speakeasy-error-message: true
              success:
                type: boolean
                default: false
              code:
                type: string
                examples:
                  - unauthorized
    NotFound:
      description: Requested resource not found
      content:
        application/json:
          schema:
            type: object
            required:
              - message
              - success
              - code
            properties:
              message:
                type: string
                x-speakeasy-error-message: true
              success:
                type: boolean
              code:
                type: string
  securitySchemes:
    Authorization:
      type: http
      description: Access token
      scheme: bearer

````